"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var fs_1 = __importDefault(require("fs"));
var path_1 = __importDefault(require("path"));
module.exports = function VueCliPluginConfig(api, projectOptions) {
    if (!process.env.X_ENV)
        process.env.X_ENV = 'development';
    var context = api.getCwd();
    var file = path_1.default.resolve(context, "config/" + process.env.X_ENV + ".env.js");
    var pkg = require(path_1.default.resolve(context, 'package.json'));
    if (!fs_1.default.existsSync(file))
        throw new Error("\u914D\u7F6E\u6587\u4EF6\u4E0D\u5B58\u5728: config/" + process.env.X_ENV + ".env.js");
    var infos = __assign({ NODE_ENV: process.env.NODE_ENV || 'development', X_ENV: process.env.X_ENV, PKG_VERSION: pkg.version, PKG_NAME: pkg.name }, require(file));
    autoTransform(infos);
    api.chainWebpack(function (webpackConfig) {
        webpackConfig.plugin('define')
            .init(function (plugin, args) {
            if (!args)
                args = [];
            if (args.length === 0)
                args[0] = {};
            if (!args[0]['process.env'])
                args[0]['process.env'] = {};
            args[0]['process.env'] = Object.assign(args[0]['process.env'], infos);
            return new (plugin.bind.apply(plugin, __spreadArrays([void 0], args)))();
        });
    });
};
/**
 * 使用 JSON.stringify 来包装所有 string 类型的值
 */
function autoTransform(objectOrArray) {
    if (typeof objectOrArray === 'object') { // 数组或对象
        if (objectOrArray instanceof Array) { // 处理数组
            objectOrArray.forEach(function (item, idx) {
                if (typeof item === 'string') {
                    objectOrArray[idx] = JSON.stringify(item);
                }
                else if (typeof item === 'object') { // 数组或对象
                    objectOrArray[idx] = autoTransform(item);
                }
            });
        }
        else { // 处理对象
            for (var key in objectOrArray) {
                if (typeof objectOrArray[key] === 'string') {
                    objectOrArray[key] = JSON.stringify(objectOrArray[key]);
                }
                else if (typeof objectOrArray[key] === 'object') { // 数组或对象
                    objectOrArray[key] = autoTransform(objectOrArray[key]);
                }
            }
        }
    }
    return objectOrArray;
}
